# Generated from Skills.g4 by ANTLR 4.13.2
from antlr4 import *
from io import StringIO
import sys
if sys.version_info[1] > 5:
    from typing import TextIO
else:
    from typing.io import TextIO


def serializedATN():
    return [
        4,0,54,449,6,-1,2,0,7,0,2,1,7,1,2,2,7,2,2,3,7,3,2,4,7,4,2,5,7,5,
        2,6,7,6,2,7,7,7,2,8,7,8,2,9,7,9,2,10,7,10,2,11,7,11,2,12,7,12,2,
        13,7,13,2,14,7,14,2,15,7,15,2,16,7,16,2,17,7,17,2,18,7,18,2,19,7,
        19,2,20,7,20,2,21,7,21,2,22,7,22,2,23,7,23,2,24,7,24,2,25,7,25,2,
        26,7,26,2,27,7,27,2,28,7,28,2,29,7,29,2,30,7,30,2,31,7,31,2,32,7,
        32,2,33,7,33,2,34,7,34,2,35,7,35,2,36,7,36,2,37,7,37,2,38,7,38,2,
        39,7,39,2,40,7,40,2,41,7,41,2,42,7,42,2,43,7,43,2,44,7,44,2,45,7,
        45,2,46,7,46,2,47,7,47,2,48,7,48,2,49,7,49,2,50,7,50,2,51,7,51,2,
        52,7,52,2,53,7,53,2,54,7,54,2,55,7,55,2,56,7,56,2,57,7,57,2,58,7,
        58,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,
        2,1,2,1,2,1,2,1,3,1,3,1,3,1,3,1,3,1,3,1,3,1,3,1,3,1,4,1,4,1,4,1,
        4,1,4,1,4,1,4,1,4,1,5,1,5,1,5,1,6,1,6,1,6,1,6,1,6,1,6,1,6,1,6,1,
        6,1,7,1,7,1,7,1,7,1,7,1,7,1,7,1,8,1,8,1,8,1,8,1,8,1,8,1,9,1,9,1,
        9,1,9,1,9,1,9,1,10,1,10,1,10,1,10,1,10,1,10,1,10,1,10,1,10,1,10,
        1,10,1,10,1,10,1,11,1,11,1,11,1,11,1,11,1,11,1,11,1,12,1,12,1,12,
        1,12,1,12,1,12,1,12,1,12,1,12,1,13,1,13,1,13,1,13,1,13,1,14,1,14,
        1,14,1,14,1,14,1,14,1,14,1,15,1,15,1,15,1,15,1,15,1,15,1,15,1,15,
        1,16,1,16,1,16,1,16,1,16,1,16,1,16,1,16,1,17,1,17,1,17,1,17,1,17,
        1,17,1,17,1,17,1,17,1,17,1,18,1,18,1,18,1,18,1,18,1,18,1,18,1,18,
        1,18,1,18,1,19,1,19,1,19,1,19,1,19,1,19,1,19,1,19,1,19,1,19,1,19,
        1,19,1,19,1,20,1,20,1,20,1,20,1,20,1,20,1,21,1,21,1,21,1,21,1,21,
        1,21,1,21,1,21,1,21,1,22,1,22,1,22,1,22,1,23,1,23,1,23,1,23,1,23,
        1,24,1,24,1,24,1,24,1,24,1,24,1,25,1,25,1,26,1,26,1,27,1,27,1,28,
        1,28,1,29,1,29,1,30,1,30,1,31,1,31,1,32,1,32,1,33,1,33,1,34,1,34,
        1,35,1,35,1,36,1,36,1,36,1,37,1,37,1,38,1,38,1,38,1,39,1,39,1,39,
        1,40,1,40,1,40,1,41,1,41,1,42,1,42,1,42,1,43,1,43,1,43,1,44,1,44,
        1,44,1,45,1,45,1,46,1,46,1,46,1,46,1,47,1,47,1,47,1,48,1,48,1,49,
        1,49,1,50,4,50,368,8,50,11,50,12,50,369,1,51,3,51,373,8,51,1,51,
        4,51,376,8,51,11,51,12,51,377,1,52,1,52,3,52,382,8,52,1,52,1,52,
        1,52,3,52,387,8,52,1,53,3,53,390,8,53,1,53,1,53,1,53,1,53,1,53,3,
        53,397,8,53,1,54,1,54,3,54,401,8,54,1,54,1,54,1,54,3,54,406,8,54,
        1,54,3,54,409,8,54,1,55,1,55,5,55,413,8,55,10,55,12,55,416,9,55,
        1,56,4,56,419,8,56,11,56,12,56,420,1,56,1,56,1,57,1,57,1,57,1,57,
        5,57,429,8,57,10,57,12,57,432,9,57,1,57,1,57,1,57,1,57,1,57,1,58,
        1,58,1,58,1,58,5,58,443,8,58,10,58,12,58,446,9,58,1,58,1,58,1,430,
        0,59,1,1,3,2,5,3,7,4,9,5,11,6,13,7,15,8,17,9,19,10,21,11,23,12,25,
        13,27,14,29,15,31,16,33,17,35,18,37,19,39,20,41,21,43,22,45,23,47,
        24,49,25,51,26,53,27,55,28,57,29,59,30,61,31,63,32,65,33,67,34,69,
        35,71,36,73,37,75,38,77,39,79,40,81,41,83,42,85,43,87,44,89,45,91,
        46,93,47,95,48,97,0,99,0,101,0,103,49,105,50,107,0,109,0,111,51,
        113,52,115,53,117,54,1,0,6,1,0,48,57,2,0,43,43,45,45,2,0,65,90,97,
        122,4,0,48,57,65,90,95,95,97,122,3,0,9,10,12,13,32,32,2,0,10,10,
        13,13,457,0,1,1,0,0,0,0,3,1,0,0,0,0,5,1,0,0,0,0,7,1,0,0,0,0,9,1,
        0,0,0,0,11,1,0,0,0,0,13,1,0,0,0,0,15,1,0,0,0,0,17,1,0,0,0,0,19,1,
        0,0,0,0,21,1,0,0,0,0,23,1,0,0,0,0,25,1,0,0,0,0,27,1,0,0,0,0,29,1,
        0,0,0,0,31,1,0,0,0,0,33,1,0,0,0,0,35,1,0,0,0,0,37,1,0,0,0,0,39,1,
        0,0,0,0,41,1,0,0,0,0,43,1,0,0,0,0,45,1,0,0,0,0,47,1,0,0,0,0,49,1,
        0,0,0,0,51,1,0,0,0,0,53,1,0,0,0,0,55,1,0,0,0,0,57,1,0,0,0,0,59,1,
        0,0,0,0,61,1,0,0,0,0,63,1,0,0,0,0,65,1,0,0,0,0,67,1,0,0,0,0,69,1,
        0,0,0,0,71,1,0,0,0,0,73,1,0,0,0,0,75,1,0,0,0,0,77,1,0,0,0,0,79,1,
        0,0,0,0,81,1,0,0,0,0,83,1,0,0,0,0,85,1,0,0,0,0,87,1,0,0,0,0,89,1,
        0,0,0,0,91,1,0,0,0,0,93,1,0,0,0,0,95,1,0,0,0,0,103,1,0,0,0,0,105,
        1,0,0,0,0,111,1,0,0,0,0,113,1,0,0,0,0,115,1,0,0,0,0,117,1,0,0,0,
        1,119,1,0,0,0,3,124,1,0,0,0,5,133,1,0,0,0,7,138,1,0,0,0,9,147,1,
        0,0,0,11,155,1,0,0,0,13,158,1,0,0,0,15,167,1,0,0,0,17,174,1,0,0,
        0,19,180,1,0,0,0,21,186,1,0,0,0,23,199,1,0,0,0,25,206,1,0,0,0,27,
        215,1,0,0,0,29,220,1,0,0,0,31,227,1,0,0,0,33,235,1,0,0,0,35,243,
        1,0,0,0,37,253,1,0,0,0,39,263,1,0,0,0,41,276,1,0,0,0,43,282,1,0,
        0,0,45,291,1,0,0,0,47,295,1,0,0,0,49,300,1,0,0,0,51,306,1,0,0,0,
        53,308,1,0,0,0,55,310,1,0,0,0,57,312,1,0,0,0,59,314,1,0,0,0,61,316,
        1,0,0,0,63,318,1,0,0,0,65,320,1,0,0,0,67,322,1,0,0,0,69,324,1,0,
        0,0,71,326,1,0,0,0,73,328,1,0,0,0,75,331,1,0,0,0,77,333,1,0,0,0,
        79,336,1,0,0,0,81,339,1,0,0,0,83,342,1,0,0,0,85,344,1,0,0,0,87,347,
        1,0,0,0,89,350,1,0,0,0,91,353,1,0,0,0,93,355,1,0,0,0,95,359,1,0,
        0,0,97,362,1,0,0,0,99,364,1,0,0,0,101,367,1,0,0,0,103,372,1,0,0,
        0,105,386,1,0,0,0,107,396,1,0,0,0,109,408,1,0,0,0,111,410,1,0,0,
        0,113,418,1,0,0,0,115,424,1,0,0,0,117,438,1,0,0,0,119,120,5,116,
        0,0,120,121,5,121,0,0,121,122,5,112,0,0,122,123,5,101,0,0,123,2,
        1,0,0,0,124,125,5,115,0,0,125,126,5,107,0,0,126,127,5,105,0,0,127,
        128,5,108,0,0,128,129,5,108,0,0,129,130,5,115,0,0,130,131,5,101,
        0,0,131,132,5,116,0,0,132,4,1,0,0,0,133,134,5,100,0,0,134,135,5,
        97,0,0,135,136,5,116,0,0,136,137,5,97,0,0,137,6,1,0,0,0,138,139,
        5,102,0,0,139,140,5,117,0,0,140,141,5,110,0,0,141,142,5,99,0,0,142,
        143,5,116,0,0,143,144,5,105,0,0,144,145,5,111,0,0,145,146,5,110,
        0,0,146,8,1,0,0,0,147,148,5,105,0,0,148,149,5,110,0,0,149,150,5,
        105,0,0,150,151,5,116,0,0,151,152,5,105,0,0,152,153,5,97,0,0,153,
        154,5,108,0,0,154,10,1,0,0,0,155,156,5,45,0,0,156,157,5,62,0,0,157,
        12,1,0,0,0,158,159,5,114,0,0,159,160,5,101,0,0,160,161,5,115,0,0,
        161,162,5,111,0,0,162,163,5,117,0,0,163,164,5,114,0,0,164,165,5,
        99,0,0,165,166,5,101,0,0,166,14,1,0,0,0,167,168,5,101,0,0,168,169,
        5,120,0,0,169,170,5,116,0,0,170,171,5,101,0,0,171,172,5,114,0,0,
        172,173,5,110,0,0,173,16,1,0,0,0,174,175,5,115,0,0,175,176,5,107,
        0,0,176,177,5,105,0,0,177,178,5,108,0,0,178,179,5,108,0,0,179,18,
        1,0,0,0,180,181,5,105,0,0,181,182,5,110,0,0,182,183,5,112,0,0,183,
        184,5,117,0,0,184,185,5,116,0,0,185,20,1,0,0,0,186,187,5,112,0,0,
        187,188,5,114,0,0,188,189,5,101,0,0,189,190,5,99,0,0,190,191,5,111,
        0,0,191,192,5,110,0,0,192,193,5,100,0,0,193,194,5,105,0,0,194,195,
        5,116,0,0,195,196,5,105,0,0,196,197,5,111,0,0,197,198,5,110,0,0,
        198,22,1,0,0,0,199,200,5,114,0,0,200,201,5,101,0,0,201,202,5,115,
        0,0,202,203,5,117,0,0,203,204,5,108,0,0,204,205,5,116,0,0,205,24,
        1,0,0,0,206,207,5,100,0,0,207,208,5,117,0,0,208,209,5,114,0,0,209,
        210,5,97,0,0,210,211,5,116,0,0,211,212,5,105,0,0,212,213,5,111,0,
        0,213,214,5,110,0,0,214,26,1,0,0,0,215,216,5,112,0,0,216,217,5,111,
        0,0,217,218,5,115,0,0,218,219,5,116,0,0,219,28,1,0,0,0,220,221,5,
        101,0,0,221,222,5,102,0,0,222,223,5,102,0,0,223,224,5,101,0,0,224,
        225,5,99,0,0,225,226,5,116,0,0,226,30,1,0,0,0,227,228,5,115,0,0,
        228,229,5,117,0,0,229,230,5,99,0,0,230,231,5,99,0,0,231,232,5,101,
        0,0,232,233,5,115,0,0,233,234,5,115,0,0,234,32,1,0,0,0,235,236,5,
        102,0,0,236,237,5,97,0,0,237,238,5,105,0,0,238,239,5,108,0,0,239,
        240,5,117,0,0,240,241,5,114,0,0,241,242,5,101,0,0,242,34,1,0,0,0,
        243,244,5,105,0,0,244,245,5,110,0,0,245,246,5,118,0,0,246,247,5,
        97,0,0,247,248,5,114,0,0,248,249,5,105,0,0,249,250,5,97,0,0,250,
        251,5,110,0,0,251,252,5,116,0,0,252,36,1,0,0,0,253,254,5,118,0,0,
        254,255,5,105,0,0,255,256,5,111,0,0,256,257,5,108,0,0,257,258,5,
        97,0,0,258,259,5,116,0,0,259,260,5,105,0,0,260,261,5,111,0,0,261,
        262,5,110,0,0,262,38,1,0,0,0,263,264,5,105,0,0,264,265,5,110,0,0,
        265,266,5,116,0,0,266,267,5,101,0,0,267,268,5,114,0,0,268,269,5,
        114,0,0,269,270,5,117,0,0,270,271,5,112,0,0,271,272,5,116,0,0,272,
        273,5,105,0,0,273,274,5,111,0,0,274,275,5,110,0,0,275,40,1,0,0,0,
        276,277,5,97,0,0,277,278,5,112,0,0,278,279,5,112,0,0,279,280,5,108,
        0,0,280,281,5,121,0,0,281,42,1,0,0,0,282,283,5,112,0,0,283,284,5,
        114,0,0,284,285,5,111,0,0,285,286,5,103,0,0,286,287,5,114,0,0,287,
        288,5,101,0,0,288,289,5,115,0,0,289,290,5,115,0,0,290,44,1,0,0,0,
        291,292,5,105,0,0,292,293,5,110,0,0,293,294,5,102,0,0,294,46,1,0,
        0,0,295,296,5,116,0,0,296,297,5,114,0,0,297,298,5,117,0,0,298,299,
        5,101,0,0,299,48,1,0,0,0,300,301,5,102,0,0,301,302,5,97,0,0,302,
        303,5,108,0,0,303,304,5,115,0,0,304,305,5,101,0,0,305,50,1,0,0,0,
        306,307,5,40,0,0,307,52,1,0,0,0,308,309,5,41,0,0,309,54,1,0,0,0,
        310,311,5,123,0,0,311,56,1,0,0,0,312,313,5,125,0,0,313,58,1,0,0,
        0,314,315,5,91,0,0,315,60,1,0,0,0,316,317,5,93,0,0,317,62,1,0,0,
        0,318,319,5,59,0,0,319,64,1,0,0,0,320,321,5,44,0,0,321,66,1,0,0,
        0,322,323,5,46,0,0,323,68,1,0,0,0,324,325,5,58,0,0,325,70,1,0,0,
        0,326,327,5,62,0,0,327,72,1,0,0,0,328,329,5,62,0,0,329,330,5,61,
        0,0,330,74,1,0,0,0,331,332,5,60,0,0,332,76,1,0,0,0,333,334,5,60,
        0,0,334,335,5,61,0,0,335,78,1,0,0,0,336,337,5,61,0,0,337,338,5,61,
        0,0,338,80,1,0,0,0,339,340,5,33,0,0,340,341,5,61,0,0,341,82,1,0,
        0,0,342,343,5,33,0,0,343,84,1,0,0,0,344,345,5,38,0,0,345,346,5,38,
        0,0,346,86,1,0,0,0,347,348,5,124,0,0,348,349,5,124,0,0,349,88,1,
        0,0,0,350,351,5,61,0,0,351,352,5,62,0,0,352,90,1,0,0,0,353,354,5,
        61,0,0,354,92,1,0,0,0,355,356,5,110,0,0,356,357,5,111,0,0,357,358,
        5,116,0,0,358,94,1,0,0,0,359,360,5,111,0,0,360,361,5,114,0,0,361,
        96,1,0,0,0,362,363,7,0,0,0,363,98,1,0,0,0,364,365,7,1,0,0,365,100,
        1,0,0,0,366,368,3,97,48,0,367,366,1,0,0,0,368,369,1,0,0,0,369,367,
        1,0,0,0,369,370,1,0,0,0,370,102,1,0,0,0,371,373,3,99,49,0,372,371,
        1,0,0,0,372,373,1,0,0,0,373,375,1,0,0,0,374,376,3,97,48,0,375,374,
        1,0,0,0,376,377,1,0,0,0,377,375,1,0,0,0,377,378,1,0,0,0,378,104,
        1,0,0,0,379,381,3,107,53,0,380,382,3,109,54,0,381,380,1,0,0,0,381,
        382,1,0,0,0,382,387,1,0,0,0,383,384,3,101,50,0,384,385,3,109,54,
        0,385,387,1,0,0,0,386,379,1,0,0,0,386,383,1,0,0,0,387,106,1,0,0,
        0,388,390,3,101,50,0,389,388,1,0,0,0,389,390,1,0,0,0,390,391,1,0,
        0,0,391,392,5,46,0,0,392,397,3,101,50,0,393,394,3,101,50,0,394,395,
        5,46,0,0,395,397,1,0,0,0,396,389,1,0,0,0,396,393,1,0,0,0,397,108,
        1,0,0,0,398,400,5,101,0,0,399,401,3,99,49,0,400,399,1,0,0,0,400,
        401,1,0,0,0,401,402,1,0,0,0,402,409,3,101,50,0,403,405,5,69,0,0,
        404,406,3,99,49,0,405,404,1,0,0,0,405,406,1,0,0,0,406,407,1,0,0,
        0,407,409,3,101,50,0,408,398,1,0,0,0,408,403,1,0,0,0,409,110,1,0,
        0,0,410,414,7,2,0,0,411,413,7,3,0,0,412,411,1,0,0,0,413,416,1,0,
        0,0,414,412,1,0,0,0,414,415,1,0,0,0,415,112,1,0,0,0,416,414,1,0,
        0,0,417,419,7,4,0,0,418,417,1,0,0,0,419,420,1,0,0,0,420,418,1,0,
        0,0,420,421,1,0,0,0,421,422,1,0,0,0,422,423,6,56,0,0,423,114,1,0,
        0,0,424,425,5,47,0,0,425,426,5,42,0,0,426,430,1,0,0,0,427,429,9,
        0,0,0,428,427,1,0,0,0,429,432,1,0,0,0,430,431,1,0,0,0,430,428,1,
        0,0,0,431,433,1,0,0,0,432,430,1,0,0,0,433,434,5,42,0,0,434,435,5,
        47,0,0,435,436,1,0,0,0,436,437,6,57,1,0,437,116,1,0,0,0,438,439,
        5,47,0,0,439,440,5,47,0,0,440,444,1,0,0,0,441,443,8,5,0,0,442,441,
        1,0,0,0,443,446,1,0,0,0,444,442,1,0,0,0,444,445,1,0,0,0,445,447,
        1,0,0,0,446,444,1,0,0,0,447,448,6,58,1,0,448,118,1,0,0,0,15,0,369,
        372,377,381,386,389,396,400,405,408,414,420,430,444,2,6,0,0,0,1,
        0
    ]

class SkillsLexer(Lexer):

    atn = ATNDeserializer().deserialize(serializedATN())

    decisionsToDFA = [ DFA(ds, i) for i, ds in enumerate(atn.decisionToState) ]

    TYPE = 1
    SKILLSET = 2
    DATA = 3
    FUNCTION = 4
    INITIAL = 5
    ARROW = 6
    RESOURCE = 7
    EXTERN = 8
    SKILL = 9
    INPUT = 10
    PRECONDITION = 11
    RESULT = 12
    DURATION = 13
    POST = 14
    EFFECT = 15
    SUCCESS = 16
    FAILURE = 17
    INVARIANT = 18
    VIOLATION = 19
    INTERRUPTION = 20
    APPLY = 21
    PROGRESS = 22
    INF = 23
    TRUE = 24
    FALSE = 25
    LPAREN = 26
    RPAREN = 27
    LBRACE = 28
    RBRACE = 29
    LBRACK = 30
    RBRACK = 31
    SEMI = 32
    COMMA = 33
    DOT = 34
    COLON = 35
    GT = 36
    GE = 37
    LT = 38
    LE = 39
    EQ = 40
    NE = 41
    NOT = 42
    AND = 43
    OR = 44
    IMPLIES = 45
    ASSIGN = 46
    NOT_USE = 47
    OR_USE = 48
    INTEGER = 49
    FLOATING = 50
    IDENTIFIER = 51
    WS = 52
    COMMENT = 53
    LINE_COMMENT = 54

    channelNames = [ u"DEFAULT_TOKEN_CHANNEL", u"HIDDEN" ]

    modeNames = [ "DEFAULT_MODE" ]

    literalNames = [ "<INVALID>",
            "'type'", "'skillset'", "'data'", "'function'", "'initial'", 
            "'->'", "'resource'", "'extern'", "'skill'", "'input'", "'precondition'", 
            "'result'", "'duration'", "'post'", "'effect'", "'success'", 
            "'failure'", "'invariant'", "'violation'", "'interruption'", 
            "'apply'", "'progress'", "'inf'", "'true'", "'false'", "'('", 
            "')'", "'{'", "'}'", "'['", "']'", "';'", "','", "'.'", "':'", 
            "'>'", "'>='", "'<'", "'<='", "'=='", "'!='", "'!'", "'&&'", 
            "'||'", "'=>'", "'='", "'not'", "'or'" ]

    symbolicNames = [ "<INVALID>",
            "TYPE", "SKILLSET", "DATA", "FUNCTION", "INITIAL", "ARROW", 
            "RESOURCE", "EXTERN", "SKILL", "INPUT", "PRECONDITION", "RESULT", 
            "DURATION", "POST", "EFFECT", "SUCCESS", "FAILURE", "INVARIANT", 
            "VIOLATION", "INTERRUPTION", "APPLY", "PROGRESS", "INF", "TRUE", 
            "FALSE", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK", 
            "SEMI", "COMMA", "DOT", "COLON", "GT", "GE", "LT", "LE", "EQ", 
            "NE", "NOT", "AND", "OR", "IMPLIES", "ASSIGN", "NOT_USE", "OR_USE", 
            "INTEGER", "FLOATING", "IDENTIFIER", "WS", "COMMENT", "LINE_COMMENT" ]

    ruleNames = [ "TYPE", "SKILLSET", "DATA", "FUNCTION", "INITIAL", "ARROW", 
                  "RESOURCE", "EXTERN", "SKILL", "INPUT", "PRECONDITION", 
                  "RESULT", "DURATION", "POST", "EFFECT", "SUCCESS", "FAILURE", 
                  "INVARIANT", "VIOLATION", "INTERRUPTION", "APPLY", "PROGRESS", 
                  "INF", "TRUE", "FALSE", "LPAREN", "RPAREN", "LBRACE", 
                  "RBRACE", "LBRACK", "RBRACK", "SEMI", "COMMA", "DOT", 
                  "COLON", "GT", "GE", "LT", "LE", "EQ", "NE", "NOT", "AND", 
                  "OR", "IMPLIES", "ASSIGN", "NOT_USE", "OR_USE", "Digit", 
                  "Sign", "DigitSequence", "INTEGER", "FLOATING", "FractionalConstant", 
                  "ExponentPart", "IDENTIFIER", "WS", "COMMENT", "LINE_COMMENT" ]

    grammarFileName = "Skills.g4"

    def __init__(self, input=None, output:TextIO = sys.stdout):
        super().__init__(input, output)
        self.checkVersion("4.13.2")
        self._interp = LexerATNSimulator(self, self.atn, self.decisionsToDFA, PredictionContextCache())
        self._actions = None
        self._predicates = None


